//+------------------------------------------------------------------+
//|                                                            
//+------------------------------------------------------------------+
#property  copyright "LukeB"
#property  link      "http://www.forexfactory.com/lukeb"
#property version "1.05"
//+------------------------------------------------------------------+
//|                                                            
//+------------------------------------------------------------------+
#property  strict
#include <stdlib.mqh>
//
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 clrCornflowerBlue 
#property indicator_width1 1
#property indicator_color2 clrViolet 
#property indicator_width2 1
//
enum ENUM_PRICE_FIELD {LOW_HIGH=0, CLOSE_CLOSE};
enum ENUM_TF_INDEX { M1Idx, M5Idx, M15Idx, M30Idx, H1Idx, H4Idx, D1Idx, W1Idx, MN1Idx, CurrentIDX, endTFIdx };
enum ENUM_OSCILLATORS {O_BEARS, O_BULLS, O_CCI, O_DEMARKER, O_FORCE, O_MOMENTUM, O_RSI, O_RVI, O_STO, O_WPR, endOscillators};
int  oscillatorBars[]={13,      13,      12,    13,         13,      12,         14,    10,    0,     14,    0};
//====================================================
extern uint        uniqueID         = 238;
extern color       controlClr       = clrCornflowerBlue;
extern int         controlXOffset   = 0;
extern int         controlYOffset   = 0;
extern string      OscillatorInput  = "== Oscillator Signal ===";
extern color       oscColor         = clrCornflowerBlue;
extern color       sigColor         = clrViolet;
extern int         signalBarsMaxVal = 50;
//====================================================
extern bool   soundAlarm     = false;
extern string closeWave      = "timeout.wav";
extern string openWave       = "Ok.wav";
extern bool   textAlarm      = false;
extern bool   priceMarks     = true;
extern int    arrowSize      = 1;
extern int    MarkSize       = 18;
extern color  sellArrowClr   = clrRosyBrown;
extern uchar  sellArrowChar  =  218;  // 218 = down arrow
extern color  buyArrowClr    = clrBlueViolet;
extern uchar  buyArrowChar   =  217;  // 217 = up arrow
//====================================================
double oscBuff[];
double sigBuff[];
//==  Control Objects ===============================================
//------- Marks ----------
enum CROSS_NAME_INDEX { HIGH_CROSS_UP=0, HIGH_CROSS_DOWN, LOW_CROSS_DOWN,  LOW_CROSS_UP, LEFT_PRICE, RIGHT_PRICE, endCrossNames};
string crossName[] =  { "HCUp",          "HCDn",          "LCDn",          "LCUp",       "LPMark",   "RPMark" };
int crossCount[endCrossNames];
//------ Control Objects ----------------------------
const int WINDOWZERO = 0;
ENUM_BASE_CORNER  WINDOW_CORNER = CORNER_RIGHT_UPPER;
ENUM_ANCHOR_POINT OBJECT_CORNER = ANCHOR_RIGHT_UPPER;
enum CONTROL_PROMPTS  {OSC_PROMPT,   SIG_TF_PROMPT, SIG_BARS_PROMPT, SIG_MULT_PROMPT, SIG_HIGH_LEVEL,   SIG_LOW_LEVEL, endControlPrompts};
string promptNames[] ={"Oscillator", "Sig_TF",      "Sig_Bars",      "Sig_Mult",      "Sig_High_Level", "Sig_Low_Level"};
int    promptXpos [] ={85,           25,            80,              80,              80,               80};
int    promptYpos [] ={10,           10,            30,              50,              70,               90};
//
enum CONTROL_INPUTS                                {SIG_BARS_BOX,    SIG_MULT_BOX,    SIG_HIGH_BOX,     SIG_LOW_BOX, endInputBoxes};
string controlNames[] =                            {"Sig_Bars_Box",  "Sig_Mult_Box",  "Sig_High_Box",   "Sig_Low_Box"};
int    controlXpos [] =                            {75,              75,              75,               75};
int    controlYpos [] =                            {30,              50,              70,               90};
// ---- Global Conrol Values ----
ENUM_OSCILLATORS oscillator;
ENUM_TIMEFRAMES         signalTF;
int signalBars;
double highSellLevel, lowBuyLevel, signalMultiplier;
string Indicator_Name = "Osc_Cross";
double markOffset;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
 {
   int initValue = INIT_SUCCEEDED;
   EventSetTimer(5);                      // create timer events / set frequency of timer events in seconds
   //
   Indicator_Name = IntegerToString(uniqueID)+Indicator_Name;
   IndicatorShortName(Indicator_Name);
   IndicatorDigits(Digits + 1);
   //
   for( CONTROL_PROMPTS i=0; i < endControlPrompts; i++ )
    {
      promptNames[i] = IntegerToString(uniqueID)+promptNames[i]+IntegerToString(i);
    }
   for( CONTROL_INPUTS i=0; i < endInputBoxes; i++ )
    {
      controlNames[i] = IntegerToString(uniqueID)+controlNames[i]+IntegerToString(i);
    }
   for( CROSS_NAME_INDEX i=0; i < endCrossNames; i++ )
    {
      crossName[i] = IntegerToString(uniqueID)+crossName[i]+IntegerToString(i);
    }
   // --- Retrieve Global Values ----
   oscillator       = getGlobalOscillatorValue();  // Always get this one first.  Other Default values are dependent.
   getOscillatorSet(oscillator);
   //
   IndicatorSetInteger(INDICATOR_LEVELS, 2);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE, STYLE_DOT);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR, clrIvory);
   IndicatorSetInteger(INDICATOR_LEVELWIDTH, 1);
   setLevelLines();  // Set the value of the lines on the Indicator window.
   //---- First Indicator Buffers Initialization -----------
   SetIndexBuffer(0,oscBuff);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2, oscColor);
   SetIndexLabel(0,"Oscillator");
   //---- 2nd Indicator Buffers Initialization -----------
   SetIndexBuffer(1,sigBuff);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2, sigColor);
   SetIndexLabel(1,"Signal");
   //
   markOffset = GetRange(40)/2;
   return(initValue);
 }
void setLevelLines(void)  // Set the value of the lines on the Indicator window.
 {
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,highSellLevel);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,lowBuyLevel);
 }
double GetRange(int rangeBars)
 {
   double rangeTotal = 0;
   if( Bars < rangeBars )
    {
      Print("Not enough Bars, at least ",IntegerToString(rangeBars)," bars are needed.");
      rangeTotal = 20*Point;
    }
   else
    {
      for( int i = 1; i < rangeBars+1; i++ )
       {
         rangeTotal += High[i]-Low[i];
       }
    }
   return(NormalizeDouble(rangeTotal/rangeBars,Digits));
 }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
 {
   // Kill Timer
   EventKillTimer();
   // Delete Arrows
   // Delete Controll Objects
   for( CONTROL_PROMPTS i=0; i < endControlPrompts; i++ )
    {
      ObjectDelete( ChartID(), promptNames[i] );
    }
   for( CONTROL_INPUTS i=0; i < endInputBoxes; i++ )
    {
      ObjectDelete( ChartID(), controlNames[i] );
    }
   for( CROSS_NAME_INDEX i = 0; i < endCrossNames; i++ )
    {
      for(int n = 1; n <= crossCount[i]; n++ )
       {
         ObjectDelete(crossName[i]+IntegerToString(n));
       }
    }
   //
   deleteMarks();
   //
   // deleteGlobalValues();  //Enable for adjusting startup defaults
   // Comment("");
 }
void deleteGlobalValues(void)
 {
   for( ENUM_OSCILLATORS i= 0; i<endOscillators; i++ )
    {
      GlobalVariableDel( getSignalTFGlobalName(i) );
      GlobalVariableDel( getSignalBarsGlobalName(i) );
      GlobalVariableDel( getHighLevelGlobalName(i) );
      GlobalVariableDel( getLowLevelGlobalName(i) );
      GlobalVariableDel( getMultiplierGlobalName(i) );
    }
   GlobalVariableDel( getOscillatorGlobalName() );
 }
void deleteMarks(void)
 {
   for( CROSS_NAME_INDEX i = 0; i < endCrossNames; i++ )
    {
      for(int n = 1; n <= crossCount[i]; n++ )
       {
         ObjectDelete(crossName[i]+IntegerToString(n));
       }
      crossCount[i] = 0;
    }
 }
//+-------------------------------------------------------------------------------------------+
//| Timer Events                                                                              |
//+-------------------------------------------------------------------------------------------+
void OnTimer()
 {
   displayControls();
 }
//+------------------------------------------------------------------+
//| Expert Chart Event Function                                      |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,  const long &lparam, const double &dparam,  const string &sparam)
 {
   bool redrawRequest = false;
   if(id==CHARTEVENT_OBJECT_CLICK)
    {
      if (sparam==promptNames[OSC_PROMPT])    // Get the Next Oscillator
       {
         redrawRequest = true;
         if(oscillator < (endOscillators-1) )
          {
            oscillator++;
          }
         else
          {
            oscillator = 0;
          }
         GlobalVariableSet(getOscillatorGlobalName(), oscillator);
         getOscillatorSet(oscillator);
       }
      if (sparam==promptNames[SIG_TF_PROMPT])    // Increase the range Period
       {
         redrawRequest = true;
         ENUM_TF_INDEX currentTFIdx = getPeriodIndex(signalTF);
         if(currentTFIdx < (endTFIdx-1) )
          {
            currentTFIdx++;
          }
         else
          {
            currentTFIdx = 0;
          }
         signalTF = findPeriodFromIndex(currentTFIdx);
         GlobalVariableSet(getSignalTFGlobalName(oscillator), signalTF);
       }
      if (sparam==promptNames[SIG_LOW_LEVEL])    // just put a way on the display to return to defaults.
       {
         redrawRequest = true;
         deleteGlobalValues();
         // --- Retrieve (Default) Global Values ----
         oscillator       = getGlobalOscillatorValue();  // Always get this one first.  Other Default values are dependent.
         getOscillatorSet(oscillator);
       }
    } 
   else if( id==CHARTEVENT_OBJECT_ENDEDIT )
    {
      if( sparam==controlNames[SIG_BARS_BOX] )    // Accept new Signal Bars value
       {
         redrawRequest = true;
         int newValue = (int) StringToInteger(ObjectGetString(ChartID(),controlNames[SIG_BARS_BOX],OBJPROP_TEXT,0));
         if( (newValue > signalBarsMaxVal) || (newValue < 1) )
          {
            newValue = signalBars;
          }
         signalBars = newValue;
         GlobalVariableSet(getSignalBarsGlobalName(oscillator), signalBars);
       }
      if( sparam==controlNames[SIG_MULT_BOX] )    // Accept new Multiplier Value
       {
         redrawRequest = true;
         double newValue = StringToDouble(ObjectGetString(ChartID(),controlNames[SIG_MULT_BOX],OBJPROP_TEXT,0));
         if( (newValue > 100000) || (newValue < 1) )
          {
            newValue = signalMultiplier;
          }
         signalMultiplier = newValue;
         GlobalVariableSet(getMultiplierGlobalName(oscillator), signalMultiplier);
       }
      if( sparam==controlNames[SIG_HIGH_BOX] )    // Accept new Multiplier Value
       {
         redrawRequest = true;
         double newValue = StringToDouble(ObjectGetString(ChartID(),controlNames[SIG_HIGH_BOX],OBJPROP_TEXT,0));
         double winMax =  NormalizeDouble( WindowPriceMax( WindowFind(Indicator_Name) ), 3);
         double winMin =  NormalizeDouble( WindowPriceMin( WindowFind(Indicator_Name) ), 3);
         if( (newValue > winMax) || (newValue < winMin) )
          {
            newValue = newValue>winMax?winMax:winMin;
          }
         highSellLevel = newValue;
         GlobalVariableSet(getHighLevelGlobalName(oscillator), highSellLevel);
       }
      if( sparam==controlNames[SIG_LOW_BOX] )    // Accept new Multiplier Value
       {
         redrawRequest = true;
         double newValue = StringToDouble(ObjectGetString(ChartID(),controlNames[SIG_LOW_BOX],OBJPROP_TEXT,0));
         double winMax =  NormalizeDouble( WindowPriceMax( WindowFind(Indicator_Name) ), 3);
         double winMin =  NormalizeDouble( WindowPriceMin( WindowFind(Indicator_Name) ), 3);
         if( (newValue > winMax) || (newValue < winMin) )
          {
            newValue = newValue>winMax?winMax:winMin;
          }
         lowBuyLevel = newValue;
         GlobalVariableSet(getLowLevelGlobalName(oscillator), lowBuyLevel);
       }
    }
   if( true==redrawRequest )
    {
      setLevelLines();
      int firstBar = Bars-(ArrayMaximum(oscillatorBars,WHOLE_ARRAY,0)+2);
      deleteMarks();
      loadSignalValues( firstBar );
      displayControls();
    }
 }
void getOscillatorSet(ENUM_OSCILLATORS oscIdx)
 {
   signalTF         = getSignalTFGlobalValue(oscIdx);
   signalBars       = getSignalBarsGlobalValue(oscIdx);
   highSellLevel    = getHighLevelGlobalValue(oscIdx);
   lowBuyLevel      = getLowLevelGlobalValue(oscIdx);
   signalMultiplier = getMultiplierGlobalValue(oscIdx);
 }
void saveOscillatorSet(ENUM_OSCILLATORS oscIdx)
 {
   GlobalVariableSet(getSignalTFGlobalName(oscIdx), signalTF);
   GlobalVariableSet(getSignalBarsGlobalName(oscIdx), signalBars);
   GlobalVariableSet(getHighLevelGlobalName(oscIdx), highSellLevel);
   GlobalVariableSet(getLowLevelGlobalName(oscIdx), lowBuyLevel);
   GlobalVariableSet(getMultiplierGlobalName(oscIdx), signalMultiplier);
 }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, const int prev_calculated, const datetime &time[], const double &open[], const double &high[],
                const double &low[], const double &close[], const long& tick_volume[], const long& volume[], const int& spread[] )
 {
   int firstBar;
   if(0==prev_calculated)   // This is the first time being executed
    {
      firstBar = rates_total-(ArrayMaximum(oscillatorBars,WHOLE_ARRAY,0)+2);
      displayControls();
    }
   else
    {
      firstBar = rates_total-prev_calculated;
    }
   loadSignalValues(firstBar);
   return(rates_total);
 }
//+------------------------------------------------------------------+
//| Load the Signal Values                                           |
//+------------------------------------------------------------------+
void loadSignalValues(const int& firstBar )
 {
   for(int barNum = firstBar; barNum>=0; barNum--)
   {
      loadBarValue(barNum);
      processHighMarks(barNum);
      processLowMarks(barNum);
   }
 }
void loadBarValue(const int& barNum)
 {
   switch (oscillator)  // ENUM_OSCILLATORS {O_BEARS, O_BULLS, O_CCI, O_DEMARKER, O_FORCE, O_MOMENTUM, O_RSI, O_RVI, O_STO, O_WPR};
    {
      case O_BEARS:    loadBears(barNum);     break;
      case O_BULLS:    loadBulls(barNum);     break;
      case O_CCI:      loadCCI(barNum);       break;
      case O_DEMARKER: loadDeMarker(barNum);  break;
      case O_FORCE:    loadForce(barNum);     break;
      case O_MOMENTUM: loadMomentum(barNum);  break;
      case O_RSI:      loadRSI(barNum);       break;
      case O_RVI:      loadRVI(barNum);       break;
      case O_STO:      loadSto(barNum);       break;
      case O_WPR:      loadWPR(barNum);       break;
      default:         loadRSI(barNum);       break;
    }
 }
void loadBears(const int& barNum)
 {
   oscBuff[barNum] = signalMultiplier * iBearsPower(Symbol(),PERIOD_CURRENT,oscillatorBars[O_BEARS],PRICE_CLOSE,barNum);
   int signalBar   = iBarShift(Symbol(),signalTF,Time[barNum],false);
   sigBuff[barNum] = signalMultiplier * iBearsPower(Symbol(),signalTF,signalBars,PRICE_CLOSE,signalBar);
 }
void loadBulls(const int& barNum)
 {
   oscBuff[barNum] = signalMultiplier * iBullsPower(Symbol(),PERIOD_CURRENT,oscillatorBars[O_BULLS],PRICE_CLOSE,barNum);
   int signalBar   = iBarShift(Symbol(),signalTF,Time[barNum],false);
   sigBuff[barNum] = signalMultiplier * iBullsPower(Symbol(),signalTF,signalBars,PRICE_CLOSE,signalBar);
 }
void loadCCI(const int& barNum)
 {
   oscBuff[barNum] = signalMultiplier * iCCI(Symbol(),PERIOD_CURRENT,oscillatorBars[O_CCI],PRICE_CLOSE,barNum);
   int signalBar   = iBarShift(Symbol(),signalTF,Time[barNum],false);
   sigBuff[barNum] = signalMultiplier * iCCI(Symbol(),signalTF,signalBars,PRICE_CLOSE,signalBar);
 }
void loadDeMarker(const int& barNum)
 {
   oscBuff[barNum] = signalMultiplier * iDeMarker(Symbol(),PERIOD_CURRENT,oscillatorBars[O_DEMARKER],barNum);
   int signalBar   = iBarShift(Symbol(),signalTF,Time[barNum],false);
   sigBuff[barNum] = signalMultiplier * iDeMarker(Symbol(),signalTF,signalBars,signalBar);
 }
void loadForce(const int& barNum)
 {
   oscBuff[barNum] = signalMultiplier * iForce(Symbol(),PERIOD_CURRENT,oscillatorBars[O_FORCE],MODE_SMA,PRICE_CLOSE,barNum);
   int signalBar   = iBarShift(Symbol(),signalTF,Time[barNum],false);
   sigBuff[barNum] = signalMultiplier * iForce(Symbol(),signalTF,signalBars,MODE_SMA,PRICE_CLOSE,signalBar);
 }
void loadMomentum(const int& barNum)
 {
   oscBuff[barNum] = signalMultiplier * iMomentum(Symbol(),PERIOD_CURRENT,oscillatorBars[O_MOMENTUM],PRICE_CLOSE,barNum);
   int signalBar   = iBarShift(Symbol(),signalTF,Time[barNum],false);
   sigBuff[barNum] = signalMultiplier * iMomentum(Symbol(),signalTF,signalBars,PRICE_CLOSE,signalBar);
 }
void loadRSI(const int& barNum)
 {
   oscBuff[barNum] = signalMultiplier * iRSI(Symbol(),PERIOD_CURRENT,oscillatorBars[O_RSI],PRICE_CLOSE,barNum);
   int signalBar   = iBarShift(Symbol(),signalTF,Time[barNum],false);
   sigBuff[barNum] = signalMultiplier * iRSI(Symbol(),signalTF,signalBars,PRICE_CLOSE,signalBar);
 }
void loadRVI(const int& barNum)
 {
   oscBuff[barNum] = signalMultiplier * iRVI(Symbol(),PERIOD_CURRENT,oscillatorBars[O_RVI],PRICE_CLOSE,barNum);
   int signalBar   = iBarShift(Symbol(),signalTF,Time[barNum],false);
   sigBuff[barNum] = signalMultiplier * iRVI(Symbol(),signalTF,signalBars,PRICE_CLOSE,signalBar);
 }
void loadSto(const int& barNum)
 { // iStochastic(symbol, timeframe, Kperiod, Dperiod, slowing, method, price_field, mode, shift)
   oscBuff[barNum] = signalMultiplier * iStochastic(Symbol(),PERIOD_CURRENT,5,3,3,MODE_SMA,(int) LOW_HIGH,MODE_SIGNAL,barNum);
   int signalBar   = iBarShift(Symbol(),signalTF,Time[barNum],false);
   sigBuff[barNum] = signalMultiplier * iStochastic(Symbol(),signalTF,5,3,3,MODE_SMA,(int) LOW_HIGH,MODE_SIGNAL,signalBar);
 }
void loadWPR(const int& barNum)
 {
   oscBuff[barNum] = signalMultiplier * iWPR(Symbol(),PERIOD_CURRENT,oscillatorBars[O_WPR],barNum);
   int signalBar   = iBarShift(Symbol(),signalTF,Time[barNum],false);
   sigBuff[barNum] = signalMultiplier * iWPR(Symbol(),signalTF,signalBars,signalBar);
 }
//+------------------------------------------------------------------+
//| Display the Controls                                             |
//+------------------------------------------------------------------+
void displayControls(void)
 {
   displayPrompts();
   displayBoxes();
 }
void displayPrompts(void)
 {
   for( CONTROL_PROMPTS i=0; i < endControlPrompts; i++ )
    {
      displayAPrompt(i);
    }
 }
void displayBoxes(void)
 {
   for( CONTROL_INPUTS i=0; i < endInputBoxes; i++ )
    {
      displayABox(i);
    }
 }
string getPromptText( CONTROL_PROMPTS promptIdx)
 {    // enum CONTROL_PROMPTS  {OSC_PROMPT,   SIG_TF_PROMPT, SIG_BARS_PROMPT, SIG_MULT_PROMPT, SIG_HIGH_LEVEL,   SIG_LOW_LEVEL, endControlPrompts}
   string promptText;
   switch (promptIdx)
    {
      case OSC_PROMPT:       promptText = getOscillatorText(oscillator);         break;
      case SIG_TF_PROMPT:    promptText = GetTFText(getPeriodIndex(signalTF));   break;
      case SIG_BARS_PROMPT:  promptText = "Bars:";                               break;
      case SIG_MULT_PROMPT:  promptText = "Multiplier:";                         break;
      case SIG_HIGH_LEVEL:   promptText = "High Level:";                         break;
      case SIG_LOW_LEVEL:    promptText = "Low Level:";                          break;
      default: promptText = "Unkown Idx: "+IntegerToString(promptIdx);           break;
    }
   return(promptText);
 }
string getOscillatorText(ENUM_OSCILLATORS OscIdx)
 {
   string oscName;
   switch (OscIdx)  // enum ENUM_OSCILLATORS {O_BEARS, O_BULLS, O_CCI, O_DEMARKER, O_FORCE, O_MOMENTUM, O_RSI, O_RVI, O_STO, O_WPR, endOscillators};
    {
      case O_BEARS:     oscName = "Bears Power";   break;
      case O_BULLS:     oscName = "Bulls Power";   break;
      case O_CCI:       oscName = "CCI (Index)";   break;
      case O_DEMARKER:  oscName = "DeMarker";      break;
      case O_FORCE:     oscName = "Force Index";   break;
      case O_MOMENTUM:  oscName = "Momentum";      break;
      case O_RSI:       oscName = "RSI (Index)";   break;
      case O_RVI:       oscName = "RVI (Index)";   break;
      case O_STO:       oscName = "Stochastic";    break;
      case O_WPR:       oscName = "WPR (Range)";   break;
      default:          oscName = "Unknown";       break;
    }
   return(oscName);
 }
string getBoxText( CONTROL_INPUTS boxIdx )
 {
   string boxText;
   switch (boxIdx)
    {
      case SIG_BARS_BOX:  boxText = IntegerToString(signalBars);         break;
      case SIG_MULT_BOX:  boxText = DoubleToString(signalMultiplier,3);  break;
      case SIG_HIGH_BOX:  boxText = DoubleToString(highSellLevel,3);     break;
      case SIG_LOW_BOX:   boxText = DoubleToString(lowBuyLevel,3);       break;
      default:            boxText = "Unknown";                           break;
    }
   return(boxText);
 }
void displayAPrompt( CONTROL_PROMPTS promptIdx )
 {
   static long chartID = ChartID();
   string objName = promptNames[promptIdx];
   if ( ObjectFind(chartID,objName) < 0 )
    {
      int dispWindow = WindowFind(Indicator_Name);
      dispWindow = (dispWindow>(-1))?dispWindow:0;
      ObjectCreate(chartID,objName,OBJ_LABEL,dispWindow,  0, 0);
      ObjectSetInteger(chartID,objName,OBJPROP_FONTSIZE,  12);
      ObjectSetString (chartID,objName,OBJPROP_FONT,      "Arial");
      ObjectSetInteger(chartID,objName,OBJPROP_COLOR,     controlClr);
      ObjectSetInteger(chartID,objName,OBJPROP_CORNER,    WINDOW_CORNER);
      ObjectSetInteger(chartID,objName,OBJPROP_ANCHOR,    OBJECT_CORNER);
      ObjectSetInteger(chartID,objName,OBJPROP_BACK,      true); 
      ObjectSetInteger(chartID,objName,OBJPROP_SELECTABLE,true); 
      ObjectSetInteger(chartID,objName,OBJPROP_SELECTED,  false); 
      ObjectSetInteger(chartID,objName,OBJPROP_HIDDEN,    true);
    }
   ObjectSetInteger(chartID,objName,OBJPROP_XDISTANCE,promptXpos[promptIdx]+controlXOffset );
   ObjectSetInteger(chartID,objName,OBJPROP_YDISTANCE,promptYpos[promptIdx]+controlYOffset );
   ObjectSetString (chartID,objName,OBJPROP_TEXT,     getPromptText(promptIdx) );
 }
void displayABox( CONTROL_INPUTS boxIdx )
 {
   static long chartID = ChartID();
   string objName = controlNames[boxIdx];
   if ( ObjectFind(chartID,objName) < 0 )
    {
      int dispWindow = WindowFind(Indicator_Name);
      dispWindow = (dispWindow>(-1))?dispWindow:0;
      ObjectCreate(chartID,objName,OBJ_EDIT,dispWindow,  0, 0);
      ObjectSetInteger(chartID,objName,OBJPROP_FONTSIZE,  10);
      ObjectSetString (chartID,objName,OBJPROP_FONT,      "Arial");
      ObjectSetInteger(chartID,objName,OBJPROP_COLOR,     controlClr);
      ObjectSetInteger(chartID,objName,OBJPROP_BORDER_COLOR,clrBlack); 
      ObjectSetInteger(chartID,objName,OBJPROP_BGCOLOR,     clrWhite);
      ObjectSetInteger(chartID,objName,OBJPROP_XSIZE,     70); 
      ObjectSetInteger(chartID,objName,OBJPROP_YSIZE,     20);
      ObjectSetInteger(chartID,objName,OBJPROP_ALIGN,     ALIGN_CENTER); 
      ObjectSetInteger(chartID,objName,OBJPROP_CORNER,    WINDOW_CORNER);
      ObjectSetInteger(chartID,objName,OBJPROP_ANCHOR,    OBJECT_CORNER);
      ObjectSetInteger(chartID,objName,OBJPROP_READONLY,  false); 
      ObjectSetInteger(chartID,objName,OBJPROP_BACK,      false); 
      ObjectSetInteger(chartID,objName,OBJPROP_SELECTABLE,false); 
      ObjectSetInteger(chartID,objName,OBJPROP_SELECTED,  false); 
      ObjectSetInteger(chartID,objName,OBJPROP_HIDDEN,    true);
    }
   ObjectSetInteger(chartID,objName,OBJPROP_XDISTANCE,controlXpos[boxIdx]+controlXOffset );
   ObjectSetInteger(chartID,objName,OBJPROP_YDISTANCE,controlYpos[boxIdx]+controlYOffset );
   ObjectSetString (chartID,objName,OBJPROP_TEXT,     getBoxText(boxIdx) );
 }
//+------------------------------------------------------------------+
//| Get Global Values                                                |
//+------------------------------------------------------------------+
// --- Get Global Variable values ------
ENUM_OSCILLATORS getGlobalOscillatorValue()
 {
   ENUM_OSCILLATORS globalValue;
   string globalName = getOscillatorGlobalName();
   if( GlobalVariableCheck(globalName) )
    {
      globalValue = (ENUM_OSCILLATORS) NormalizeDouble(GlobalVariableGet(globalName),0);
    }
   else
    {
      globalValue = O_RSI;
    }
   return(globalValue);
 }
ENUM_TIMEFRAMES getSignalTFGlobalValue(ENUM_OSCILLATORS oscIdx)
 {
   ENUM_TIMEFRAMES globalValue;
   string globalName = getSignalTFGlobalName(oscIdx);
   if( GlobalVariableCheck(globalName) )
    {
      globalValue = (ENUM_TIMEFRAMES) NormalizeDouble(GlobalVariableGet(globalName),0);
    }
   else
    {
      globalValue = PERIOD_CURRENT;
    }
   return(globalValue);
 }
int getSignalBarsGlobalValue(ENUM_OSCILLATORS oscIdx)
 {
   int globalValue;
   string globalName = getSignalBarsGlobalName(oscIdx);
   if( GlobalVariableCheck(globalName) )
    {
      globalValue = (int) NormalizeDouble(GlobalVariableGet(globalName),0);
    }
   else
    {
      globalValue = oscillatorBars[oscillator];
    }
   return(globalValue);
 }
double getHighLevelGlobalValue(ENUM_OSCILLATORS oscIdx)
 {
   double globalValue;
   string globalName = getHighLevelGlobalName(oscIdx);
   if( GlobalVariableCheck(globalName) )
    {
      globalValue = NormalizeDouble(GlobalVariableGet(globalName),Digits);
    }
   else
    {
      globalValue = getDefaultHighLevel(oscillator);
    }
   return(globalValue);
 }
double getLowLevelGlobalValue(ENUM_OSCILLATORS oscIdx)
 {
   double globalValue;
   string globalName = getLowLevelGlobalName(oscIdx);
   if( GlobalVariableCheck(globalName) )
    {
      globalValue = NormalizeDouble(GlobalVariableGet(globalName),Digits);
    }
   else
    {
      globalValue = getDefaultlowLevel(oscillator);
    }
   return(globalValue);
 }
double getMultiplierGlobalValue(ENUM_OSCILLATORS oscIdx)
 {
   double globalValue;
   string globalName = getMultiplierGlobalName(oscIdx);
   if( GlobalVariableCheck(globalName) )
    {
      globalValue = NormalizeDouble(GlobalVariableGet(globalName),3);
    }
   else
    {
      globalValue = getDefaultMultiplier(oscillator);
    }
   return(globalValue);
 }
//------ Default Values per Oscillator ---------
double getDefaultHighLevel(ENUM_OSCILLATORS OscIdx)
 {
   double defaultValue;
   switch (OscIdx)  // enum ENUM_OSCILLATORS {O_BEARS, O_BULLS, O_CCI, O_DEMARKER, O_FORCE, O_MOMENTUM, O_RSI, O_RVI, O_STO, O_WPR, endOscillators};
    {
      case O_BEARS:     defaultValue = 35;       break;
      case O_BULLS:     defaultValue = 30;       break;
      case O_CCI:       defaultValue = 40;       break;
      case O_DEMARKER:  defaultValue = 65;       break;
      case O_FORCE:     defaultValue = 25;       break;
      case O_MOMENTUM:  defaultValue = 100.3;    break;
      case O_RSI:       defaultValue = 70;       break;
      case O_RVI:       defaultValue = 24;       break;
      case O_STO:       defaultValue = 75;       break;
      case O_WPR:       defaultValue = -27;      break;
      default:          defaultValue = 70;       break;
    }
   return(defaultValue);
 }
double getDefaultlowLevel(ENUM_OSCILLATORS OscIdx)
 {
   double defaultValue;
   switch (OscIdx)  // enum ENUM_OSCILLATORS {O_BEARS, O_BULLS, O_CCI, O_DEMARKER, O_FORCE, O_MOMENTUM, O_RSI, O_RVI, O_STO, O_WPR, endOscillators};
    {
      case O_BEARS:     defaultValue = -45;      break;
      case O_BULLS:     defaultValue = -8.0;     break;
      case O_CCI:       defaultValue = -35;      break;
      case O_DEMARKER:  defaultValue = 20;       break;
      case O_FORCE:     defaultValue = -18;      break;
      case O_MOMENTUM:  defaultValue = 99.7;     break;
      case O_RSI:       defaultValue = 40;       break;
      case O_RVI:       defaultValue = -19;      break;
      case O_STO:       defaultValue = 20;       break;
      case O_WPR:       defaultValue = -73;      break;
      default:          defaultValue = 30;       break;
    }
   return(defaultValue);
 }
double getDefaultMultiplier(ENUM_OSCILLATORS OscIdx)
 {
   double defaultValue;
   switch (OscIdx)  // enum ENUM_OSCILLATORS {O_BEARS, O_BULLS, O_CCI, O_DEMARKER, O_FORCE, O_MOMENTUM, O_RSI, O_RVI, O_STO, O_WPR, endOscillators};
    {
      case O_BEARS:     defaultValue = 20000;   break;
      case O_BULLS:     defaultValue = 10000;   break;
      case O_CCI:       defaultValue = 0.25;    break;
      case O_DEMARKER:  defaultValue = 100;     break;
      case O_FORCE:     defaultValue = 30;       break;
      case O_MOMENTUM:  defaultValue = 1;       break;
      case O_RSI:       defaultValue = 1;       break;
      case O_RVI:       defaultValue = 100;     break;
      case O_STO:       defaultValue = 1;       break;
      case O_WPR:       defaultValue = 1;       break;
      default:          defaultValue = 1;       break;
    }
   return(defaultValue);
 }
// --- Make and get Global Variable Names ------
string getOscillatorGlobalName(void)
 {
   return(IntegerToString(uniqueID)+"Oscillator"+Symbol());
 }
string getSignalTFGlobalName(ENUM_OSCILLATORS OscIdx)
 {
   return(IntegerToString(uniqueID)+"SignalTF"+IntegerToString(OscIdx)+Symbol());
 }
string getSignalBarsGlobalName(ENUM_OSCILLATORS OscIdx)
 {
   return(IntegerToString(uniqueID)+"SignalBars"+IntegerToString(OscIdx)+Symbol());
 }
string getHighLevelGlobalName(ENUM_OSCILLATORS OscIdx)
 {
   return(IntegerToString(uniqueID)+"HighLevel"+IntegerToString(OscIdx)+Symbol());
 }
string getLowLevelGlobalName(ENUM_OSCILLATORS OscIdx)
 {
   return(IntegerToString(uniqueID)+"LowLevel"+IntegerToString(OscIdx)+Symbol());
 }
string getMultiplierGlobalName(ENUM_OSCILLATORS OscIdx)
 {
   return(IntegerToString(uniqueID)+"Multiplier"+IntegerToString(OscIdx)+Symbol());
 }
//+------------------------------------------------------------------+
//| ENUM_TIMEFRAME Utilities                                         |
//+------------------------------------------------------------------+
string GetTFText(ENUM_TF_INDEX tfIdx)
 {  // enum ENUM_TF_INDEX { M1Idx, M5Idx, M15Idx, M30Idx, H1Idx, H4Idx, D1Idx, W1Idx, MN1Idx, CurrentIDX, endTFIdx };
   string tfText;
   switch (tfIdx)
    {
      case M1Idx:      tfText="M1";      break;
      case M5Idx:      tfText="M5";      break;
      case M15Idx:     tfText="M15";     break;
      case M30Idx:     tfText="M30";     break;
      case H1Idx:      tfText="H1";      break;
      case H4Idx:      tfText="H4";      break;
      case D1Idx:      tfText="D1";      break;
      case W1Idx:      tfText="W1";      break;
      case MN1Idx:     tfText="MN1";     break;
      case CurrentIDX: tfText="Current"; break;
      default:
         Print(__FUNCTION__,", Invalide Timeframe Index: ",IntegerToString(tfIdx),", Using \"Unknown\"");
         tfText="Unknown";
         break;
    }
   return(tfText);
 }
ENUM_TIMEFRAMES findPeriodFromIndex(ENUM_TF_INDEX tfIdx)
 {
    ENUM_TIMEFRAMES tfPeriod;
    switch (tfIdx)
    {
      case M1Idx:      tfPeriod = PERIOD_M1;      break;
      case M5Idx:      tfPeriod = PERIOD_M5;      break;
      case M15Idx:     tfPeriod = PERIOD_M15;     break;
      case M30Idx:     tfPeriod = PERIOD_M30;     break;
      case H1Idx:      tfPeriod = PERIOD_H1;      break;
      case H4Idx:      tfPeriod = PERIOD_H4;      break;
      case D1Idx:      tfPeriod = PERIOD_D1;      break;
      case W1Idx:      tfPeriod = PERIOD_W1;      break;
      case MN1Idx:     tfPeriod = PERIOD_MN1;     break;
      case CurrentIDX: tfPeriod = PERIOD_CURRENT; break;
      default:
         Print(__FUNCTION__,", Invalide Timeframe Index: ",IntegerToString(tfIdx),", Using: ", IntegerToString(Period()));
         tfPeriod= (ENUM_TIMEFRAMES) Period();
         break;
    }
   return(tfPeriod);
 }
ENUM_TF_INDEX getPeriodIndex(ENUM_TIMEFRAMES tf)
 { //enum ENUM_TF_INDEX = {M1Idx, M5Idx, M15Idx, M30Idx, H1Idx, H4Idx, D1Idx, W1Idx, MN1Idx, endTFIdxENUM_TF_INDEX };
   ENUM_TF_INDEX tfIdx;
   switch (tf)
    {
      case PERIOD_M1:      tfIdx=M1Idx;  break;
      case PERIOD_M5:      tfIdx=M5Idx;  break;
      case PERIOD_M15:     tfIdx=M15Idx; break;
      case PERIOD_M30:     tfIdx=M30Idx; break;
      case PERIOD_H1:      tfIdx=H1Idx;  break;
      case PERIOD_H4:      tfIdx=H4Idx;  break;
      case PERIOD_D1:      tfIdx=D1Idx;  break;
      case PERIOD_W1:      tfIdx=W1Idx;  break;
      case PERIOD_MN1:     tfIdx=MN1Idx; break;
      case PERIOD_CURRENT: tfIdx=CurrentIDX;  break;
      default:
         Print(__FUNCTION__,", Invalide Timeframe: ",IntegerToString(tf),", Using \"M15Idx\"");
         tfIdx=M15Idx;
         break;
    }
   return(tfIdx);
 }
//+------------------------------------------------------------------+
//| Draw the Arrows                                                  |
//+------------------------------------------------------------------+
void processHighMarks(const int& barNum)
 {
   static bool upMarkSet = false;
   static bool downMarkSet = false;
   if( (false == upMarkSet) && (sigBuff[barNum]>highSellLevel) && (sigBuff[barNum+1]<=highSellLevel) ) // High Cross to the upside
    { // enum CROSS_NAME_INDEX { HIGH_CROSS_UP=0, HIGH_CROSS_DOWN, LOW_CROSS_DOWN,  LOW_CROSS_UP, LEFT_PRICE, RIGHT_PRICE, endCrossNames};
      upMarkSet          = true;
      string nameStr     = makeObjectName(crossName[HIGH_CROSS_UP], crossCount[HIGH_CROSS_UP]);
      double price       = (High[barNum+1]>High[barNum]?High[barNum+1]:High[barNum]) + (markOffset);
      string displayStr  = CharToString(buyArrowChar);
      makeAnArrow( nameStr, price, Time[barNum], displayStr, buyArrowClr );
      //
      string priceNameStr = makeObjectName(crossName[LEFT_PRICE], crossCount[LEFT_PRICE]);
      price = (barNum==0)?Ask:Close[barNum];
      makeAPriceMark( priceNameStr, price, Time[barNum], OBJ_ARROW_LEFT_PRICE, clrYellowGreen);
      //
      if(2>barNum)
       {
         if( soundAlarm ) PlaySound(closeWave);
         //
         if( textAlarm )
          {
            string msgText = getOscillatorText(oscillator)+"Signal has risen through the high level- Close Long";
            SendNotification( msgText );
          }
       }
    }
   else if( (false == downMarkSet) && (sigBuff[barNum]<highSellLevel) && (sigBuff[barNum+1]>=highSellLevel) ) // High Cross to the downside
    {
      downMarkSet        = true;
      string nameStr     = makeObjectName(crossName[HIGH_CROSS_DOWN], crossCount[HIGH_CROSS_DOWN]);
      double price       = (High[barNum+1]>High[barNum]?High[barNum+1]:High[barNum]) + (markOffset);
      string displayStr  = CharToString(sellArrowChar);
      makeAnArrow( nameStr, price, Time[barNum], displayStr, sellArrowClr );
      //
      string priceNameStr = makeObjectName(crossName[RIGHT_PRICE], crossCount[RIGHT_PRICE]);
      price = (barNum==0)?Bid:Close[barNum];
      makeAPriceMark( priceNameStr, price, Time[barNum], OBJ_ARROW_RIGHT_PRICE, clrOrangeRed);
      //
      if(2>barNum)
       {
         if( soundAlarm ) PlaySound(openWave);
         //
         if( textAlarm )
          {
            string msgText = getOscillatorText(oscillator)+"Signal has dropped through the high level - Go Short";
            SendNotification( msgText );
          }
       }
    }
   else if( sigBuff[barNum] < (highSellLevel-(highSellLevel-lowBuyLevel)/4) )  // clear, allow marks to be set again.
    {
      upMarkSet = false; downMarkSet = false;
    }
 }
void processLowMarks(const int& barNum)
 {
   static bool upMarkSet = false;
   static bool downMarkSet = false;
   if( (false == upMarkSet) && (sigBuff[barNum]>lowBuyLevel) && (sigBuff[barNum+1]<=lowBuyLevel) ) // Low Cross to the upside
    { // enum CROSS_NAME_INDEX { HIGH_CROSS_UP=0, HIGH_CROSS_DOWN, LOW_CROSS_DOWN,  LOW_CROSS_UP, LEFT_PRICE, RIGHT_PRICE, endCrossNames};
      upMarkSet          = true;
      string nameStr     = makeObjectName(crossName[LOW_CROSS_UP], crossCount[LOW_CROSS_UP]);
      double price       = (Low[barNum+1]<Low[barNum]?Low[barNum+1]:Low[barNum]) - (markOffset);
      string displayStr  = CharToString(buyArrowChar);
      makeAnArrow( nameStr, price, Time[barNum], displayStr, buyArrowClr );
      //
      string priceNameStr = makeObjectName(crossName[RIGHT_PRICE], crossCount[RIGHT_PRICE]);
      price = (barNum==0)?Ask:Close[barNum];
      makeAPriceMark( priceNameStr, price, Time[barNum], OBJ_ARROW_RIGHT_PRICE, clrYellowGreen);
      //
      if(2>barNum)
       {
         if( soundAlarm ) PlaySound(openWave);
         //
         if( textAlarm )
          {
            string msgText = getOscillatorText(oscillator)+"Signal has risen through the low level - Go Long";
            SendNotification( msgText );
          }
       }
    }
   else if( (false == downMarkSet) && (sigBuff[barNum]<lowBuyLevel) && (sigBuff[barNum+1]>=lowBuyLevel) ) // Low Cross to the downside
    {
      downMarkSet        = true;
      string nameStr     = makeObjectName(crossName[LOW_CROSS_DOWN], crossCount[LOW_CROSS_DOWN]);
      double price       = (Low[barNum+1]<Low[barNum]?Low[barNum+1]:Low[barNum]) - (markOffset);
      string displayStr  = CharToString(sellArrowChar);
      makeAnArrow( nameStr, price, Time[barNum], displayStr, sellArrowClr );
      //
      string priceNameStr = makeObjectName(crossName[RIGHT_PRICE], crossCount[RIGHT_PRICE]);
      price = (barNum==0)?Bid:Close[barNum];
      makeAPriceMark( priceNameStr, price, Time[barNum], OBJ_ARROW_LEFT_PRICE, clrOrangeRed);
      //
      if(2>barNum)
       {
         if( soundAlarm ) PlaySound(closeWave);
         //
         if( textAlarm )
          {
            string msgText = getOscillatorText(oscillator)+"Signal has dropped through the low level - Close Short";
            SendNotification( msgText );
          }
       }
    }
   else if( sigBuff[barNum] > (lowBuyLevel+(highSellLevel-lowBuyLevel)/4) )  // clear, allow marks to be set again.
    {
      upMarkSet = false; downMarkSet = false;
    }
 }
string makeObjectName( const string& objToName, int& objCount)
 {
   objCount++;
   return(objToName+IntegerToString(objCount) );
 }
//+------------------------------------------------------------------+
//| Draw the Arrows                                                  |
//+------------------------------------------------------------------+
void makeAnArrow( const string& objNameStr, const double& price, const datetime& time, const string& markChar, const color& markClr)
 {
   static long chartID = ChartID();
   //
   int windowIndex = ObjectFind(objNameStr);
   if( windowIndex < 0 )                      // Not found, create - This should be the case every time in this implementation
    { // bool  ObjectCreate( long chart_id, string object_name, ENUM_OBJECT object_type, int sub_window, datetime time1, double price1) 
      ObjectCreate( chartID, objNameStr,  OBJ_TEXT, WINDOWZERO, time, price );
      ObjectSetDouble(chartID,objNameStr, OBJPROP_ANGLE,     0);
      ObjectSetInteger(chartID,objNameStr,OBJPROP_SELECTABLE,false); 
      ObjectSetInteger(chartID,objNameStr,OBJPROP_SELECTED,  false);
      ObjectSetInteger(chartID,objNameStr,OBJPROP_ANCHOR,    ANCHOR_CENTER);
      ObjectSetInteger(chartID,objNameStr,OBJPROP_COLOR,     markClr);
      ObjectSetString(chartID,objNameStr, OBJPROP_TEXT,      markChar);
      ObjectSetString(chartID,objNameStr, OBJPROP_FONT,      "Wingdings");
      ObjectSetInteger(chartID,objNameStr,OBJPROP_FONTSIZE,  MarkSize);
      ObjectSet(objNameStr,OBJPROP_HIDDEN,true);             // Hidden, must press 'all' to see in object list
      ObjectSet(objNameStr,OBJPROP_BACK,  true);             // Display on top of Background
    }
 }
void makeAPriceMark( const string& objNameStr, const double& price, const datetime& time, ENUM_OBJECT leftOrRight, const color priceClr)
 {
   if( priceMarks )
    { 
      static long chartID = ChartID();
      //
      int windowIndex = ObjectFind(objNameStr);
      if( windowIndex < 0 )                      // Not found, create - This should be the case every time in this implementation
       { // bool  ObjectCreate( long chart_id, string object_name, ENUM_OBJECT object_type, int sub_window, datetime time1, double price1)
         ObjectCreate( chartID, objNameStr,  leftOrRight, WINDOWZERO, time, price );
         ObjectSetInteger( chartID, objNameStr, OBJPROP_COLOR,      priceClr);
         ObjectSetInteger( chartID, objNameStr, OBJPROP_STYLE,      STYLE_SOLID);
         ObjectSetInteger( chartID, objNameStr, OBJPROP_WIDTH,      1 );
         ObjectSetInteger( chartID, objNameStr, OBJPROP_BACK,       false);
         ObjectSetInteger( chartID, objNameStr, OBJPROP_SELECTABLE, false);
         ObjectSetInteger( chartID, objNameStr, OBJPROP_SELECTED,   false);
         ObjectSetInteger( chartID, objNameStr, OBJPROP_HIDDEN,     true);
       }
    }
 }
//--------------------------------------------------------------------